<template>
    <div class="user-group">
        <el-collapse accordion>
            <el-collapse-item :name="group.name" v-for="(group, index) in groups" :key="index">
                <template slot="title">
                    <div class="user-group__title">
                        <div class="input"  v-if="editGroupName == group.name">
                            <input type="text"
                                   class="input__text input__text--underline"
                                   placeholder="Edit group name"
                                   @keyup.enter="editGroup(group.id, $event)"
                                   :value="group.name"/>
                            <i class="fa fa-times input__icon" aria-hidden="true" @click="editGroupName = ''" style="top: 35%"></i>
                        </div>

                        <span v-else>{{ group.name }}</span>

                        <div class="user-group__title__btn">
                            <button @click="editGroupName = group.name" v-show="editGroupName == ''"><i class="fa fa-pencil" aria-hidden="true"></i>
                            </button>

                            <button @click="deleteGroup(group.id)"><i class="fa fa-trash-o" aria-hidden="true"></i>
                            </button>
                        </div>
                    </div>
                </template>

                <ul class="user-group__user-list">
                    <li v-for="user in group.users">
                        <div class="user-group__title">
                            <span class="user-group__title--light">{{ user.name }}</span>

                            <div class="user-group__title__btn">
                                <button @click="deleteUser(group.id, user.id)" class="user-group__title__btn--margin">
                                    <i class="fa fa-times" aria-hidden="true"></i>
                                </button>
                            </div>
                        </div>
                    </li>
                </ul>

                <div class="clean-input">
                    <input type="text" @keyup.enter="addUser(group.id, $event)" placeholder="Type a user name to add to the group...">
                </div>
            </el-collapse-item>

            <div class="user-group__create-group">
                <div class="input">
                    <input type="text"
                           class="input__text input__text--underline"
                           placeholder="Create a new group..."
                           @keyup.enter="addGroup"/>
                </div>
            </div>
        </el-collapse>
    </div>
</template>

<script>
    import getData from '../mixins/getData'

    export default {
        name: 'Groups',
        mixins: [getData],
        data() {
            return {
                groups: [],
                editGroupName: ''
            }
        },
        mounted() {
            this.asyncGetData({
                method: 'GET',
                url: 'admin/get/team/list'
            }).then(response => {
                this.groups = response.data
            })
        },
        methods: {
            editGroup(groupID, event) {
                this.asyncGetData({
                    method: 'PUT',
                    url: 'admin/edit/team',
                    data: {
                        team_id: groupID,
                        value: event.target.value
                    }
                }).then(response => {
                    if (response.status) {
                        this.groups = response.data

                        this.editGroupName = ''

                        // Success message
                        this.$message({
                            message: 'Group name successfully changed.',
                            type: 'success',
                            showClose: true
                        })
                    }
                })
            },
            deleteUser(groupID, userID) {
                this.asyncGetData({
                    method: 'DELETE',
                    url: 'admin/delete/team/user',
                    data: {
                        team_id: groupID,
                        user_id: userID
                    }
                }).then(response => {
                    if (response.status) {
                        this.groups = response.data
                        // Success message
                        this.$message({
                            message: 'User successfully deleted.',
                            type: 'success',
                            showClose: true
                        })
                    }
                })
            },
            deleteGroup(groupID) {
                this.asyncGetData({
                    method: 'DELETE',
                    url: 'admin/delete/team',
                    data: {
                        team_id: groupID
                    }
                }).then(response => {
                    if (response.status) {
                        this.groups = response.data
                        // Success message
                        this.$message({
                            message: 'Group successfully deleted.',
                            type: 'success',
                            showClose: true
                        })
                    }
                })
            },
            addGroup(event) {
                this.asyncGetData({
                    method: 'POST',
                    url: 'admin/add/team',
                    data: {
                        name: event.target.value,
                    }
                }).then(response => {
                    if (response.status) {
                        this.groups = response.data

                        event.target.value = ''

                        // Success message
                        this.$message({
                            message: 'Group successfully added.',
                            type: 'success',
                            showClose: true
                        })
                    }
                })
            },
            addUser(groupID, event) {
                this.asyncGetData({
                    method: 'POST',
                    url: 'admin/add/team/user',
                    data: {
                        name: event.target.value,
                        team_id: groupID
                    }
                }).then(response => {
                    if (response.status) {
                        this.groups = response.data

                        event.target.value = ''
                        // Success message
                        this.$message({
                            message: 'User successfully added.',
                            type: 'success',
                            showClose: true
                        })
                    }
                })
            }
        }
    }
</script>
